<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 11/04/2009 *
 * ===================                          Last change: 11/04/2009 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_network_data.php                       *
 * -------------------------------------------------------------------- *
 * Short description : List all supported sponsor networks              *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Listet alle supportierten Werbenetzwerke auf     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2012 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

// These are expert settings!
if (doVerifyExpertSettings() != 'agreed') {
	// Abort here
	return;
} // END - if

// By default we should display list/add new forms
$GLOBALS['network_display'] = true;

// Handle form here
doNetworkHandleForm();

// Display forms?
if ($GLOBALS['network_display'] === false) {
	// Abort here
	return;
} // END - if

// Query for networks
$result = SQL_QUERY('SELECT
	`network_id`,
	`network_short_name`,
	`network_title`,
	`network_reflink`,
	`network_data_separator`,
	`network_row_separator`,
	`network_request_type`,
	`network_charset`,
	`network_require_id_card`,
	`network_query_amount`
FROM
	`{?_MYSQL_PREFIX?}_network_data`
ORDER BY
	`network_short_name` ASC', __FILE__, __LINE__);

// Are there entries?
if (!SQL_HASZERONUMS($result)) {
	// List all
	$OUT = '';
	while ($content = SQL_FETCHARRAY($result)) {
		// Load row template
		$OUT .= loadTemplate('admin_list_network_data_row', true, $content);
	} // END - while

	// Load main template
	loadTemplate('admin_list_network_data', false, $OUT);
} else {
	// Display a message that there are sponsor networks supported, yet
	displayMessage('{--ADMIN_NETWORK_NONE_SUPPORTED--}');
}

// Free result
SQL_FREERESULT($result);

// Add form for adding new entry
loadTemplate('admin_add_network');

// [EOF]
?>
