<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 06/10/2005 *
 * ===================                          Last change: 05/19/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_sponsor_pay.php                        *
 * -------------------------------------------------------------------- *
 * Short description : List/edit/delete all payments and add new        *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auflisten/Aendern/Loeschen aller Buchungspakete  *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2012 by Mailer Developer Team                   *
 * For more information visit: http://mxchange.org                      *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

$message = '';

if (isFormSent('add')) {
	// Check input variables
	if (!isPostRequestElementSet('pay_name')) unsetPostRequestElement('add');
	if ((round(postRequestElement('pay_rate')) == 0) || (!isPostRequestElementSet('pay_rate'))) unsetPostRequestElement('add');

	setPostRequestElement('pay_min_count', bigintval(postRequestElement('pay_min_count')));

	if ((postRequestElement('pay_min_count') == '0') || (!isPostRequestElementSet('pay_min_count'))) unsetPostRequestElement('add');
	if (!isPostRequestElementSet('pay_currency')) unsetPostRequestElement('add');

} elseif ((isFormSent('edit')) || (isFormSent('delete')) || (isFormSent('do_edit')) || (isFormSent('do_delete'))) {
	// Check if at least one entry was selected
	if (!isPostRequestElementSet('id')) {
		// Nothing selected for editing / deleting???
		unsetPostRequestElement('edit');
		unsetPostRequestElement('delete');
		unsetPostRequestElement('do_edit');
		unsetPostRequestElement('do_delete');
	} elseif (isFormSent('do_edit')) {
		// Change entries here...
		foreach (postRequestElement('id') as $id => $sel) {
			// Secure id
			$id = bigintval($id);

			// Save entry
			SQL_QUERY_ESC("UPDATE
	`{?_MYSQL_PREFIX?}_sponsor_paytypes`
SET
	`pay_name`='%s',
	`pay_rate`='%s',
	`pay_min_count`='%s',
	`pay_currency`='%s'
WHERE
	`id`=%s
LIMIT 1",
			array(
				postRequestElement('name', $id),
				postRequestElement('rate', $id),
				bigintval(postRequestElement('min', $id)),
				postRequestElement('curr', $id),
				$id
			), __FILE__, __LINE__);
		}

		// Generate message
		$message = '{--SPONSOR_PAY_ENTRIES_CHANGED--}';
	} elseif (isFormSent('do_delete')) {
		// Remove entries here...
		foreach (postRequestElement('id') as $id => $sel) {
			// Remove entry
			SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_sponsor_paytypes` WHERE `id`=%s LIMIT 1",
				array(bigintval($id)), __FILE__, __LINE__);
		}

		// Generate message
		$message = '{--SPONSOR_PAY_ENTRIES_REMOVED--}';
	}

	if (!empty($message)) {
		// Output message
		displayMessage($message);
	} // END - if
}

if (isFormSent('add')) {
	// Check if entry with same name does exists
	$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_sponsor_paytypes` WHERE `pay_name`='%s' LIMIT 1",
		array(postRequestElement('pay_name')), __FILE__, __LINE__);
	if (SQL_HASZERONUMS($result)) {
		// No entry found so add this line
		SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_sponsor_paytypes` (`pay_name`, `pay_rate`, `pay_min_count`, `pay_currency`) VALUES ('%s','%s','%s','%s')",
			array(
				postRequestElement('pay_name'),
				convertCommaToDot(postRequestElement('pay_rate')),
				bigintval(postRequestElement('pay_min_count')),
				postRequestElement('pay_currency')
			), __FILE__, __LINE__);

		// Payment type added!
		$message = '{%message,ADMIN_SPONSOR_PAYTYPE_ADDED=' . postRequestElement('pay_name') . '%}';
	} else {
		// Entry does already exists
		$message = '{%message,ADMIN_SPONSOR_PAYTYPE_ALREADY=' . postRequestElement('pay_name') . '%}';
	}

	// Free memory
	SQL_FREERESULT($result);

	// Output message
	displayMessage($message);
} elseif ((isFormSent('edit')) || (isFormSent('delete'))) {
	// Load all data
	$OUT = '';
	foreach (postRequestElement('id') as $id => $sel) {
		// Load entry
		$result = SQL_QUERY_ESC("SELECT `id`, `pay_name`, `pay_rate`, `pay_min_count`, `pay_currency` FROM `{?_MYSQL_PREFIX?}_sponsor_paytypes` WHERE `id`=%s LIMIT 1",
			array(bigintval($id)), __FILE__, __LINE__);
		if (SQL_NUMROWS($result) == 1) {
			// Load data
			$content = SQL_FETCHARRAY($result);

			if (isFormSent('edit')) {
				// Edit entry
				$OUT .= loadTemplate('admin_list_sponsor_pay_edit_row', true, $content);
			} else {
				// Delete entry
				$OUT .= loadTemplate('admin_list_sponsor_pay_del_row', true, $content);
			}
		} else {
			// Entry invalid
			$OUT .= loadTemplate('admin_list_sponsor_pay_404', true, $id);
		}

		// Free result
		SQL_FREERESULT($result);
	} // END - foreach

	// Load main template depending on mode (edit/delete)
	if (isFormSent('edit')) {
		// Load main edit template
		loadTemplate('admin_list_sponsor_pay_edit', false, $OUT);
	} else {
		// Load main delete template
		loadTemplate('admin_list_sponsor_pay_del', false, $OUT);
	}
} else {
	// Load all payment types
	$result = SQL_QUERY("SELECT
	`id`,
	`pay_name`,
	`pay_rate`,
	`pay_min_count`,
	`pay_currency`
FROM
	`{?_MYSQL_PREFIX?}_sponsor_paytypes`
ORDER BY
	`pay_name` ASC",
		__FILE__, __LINE__);

	// Are there some payment types setup?
	if (!SQL_HASZERONUMS($result)) {
		// Prepare variables for listing
		$OUT = '';

		// List alle found payment types
		while ($content = SQL_FETCHARRAY($result)) {
			// Add row
			$OUT .= loadTemplate('admin_list_sponsor_pay_row', true, $content);
		} // END - while

		// Load list template
		$content['list_out'] = loadTemplate('admin_list_sponsor_pay', true, $OUT);
	} else {
		// Noting setup so far!
		$content['list_out'] = displayMessage('{--ADMIN_SPONSOR_NO_PAYTYPES--}', true);
	}

	// Free memory
	SQL_FREERESULT($result);

	// Add new payment types here
	$content['add_out'] = loadTemplate('admin_add_sponsor_paytype', true);

	// Load final template
	loadTemplate('admin_sponsor_paytypes', false, $content);
}

// [EOF]
?>
